SELECT 
	AccountNumber,
	OrderDate, 
	FIRST_VALUE(OrderDate) OVER (PARTITION BY AccountNumber ORDER BY OrderDate) AS FirstOrderDate,
	LAST_VALUE(OrderDate) OVER (PARTITION BY AccountNumber ORDER BY OrderDate) AS LastOrderDate
FROM AdventureWorks2012.Sales.SalesOrderHeader


-- Let's see how Framing helps here
SELECT 
	AccountNumber,
	OrderDate, 
	First_VALUE(OrderDate) 
		OVER (	PARTITION BY AccountNumber 
				ORDER BY OrderDate 
				ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) AS FirstOrderDate,
	LAST_VALUE(OrderDate) 
		OVER (	PARTITION BY AccountNumber 
				ORDER BY OrderDate 
				ROWS BETWEEN CURRENT ROW AND UNBOUNDED FOLLOWING) AS LastOrderDate
FROM AdventureWorks2012.Sales.SalesOrderHeader

SET STATISTICS TIME ON
SET STATISTICS IO ON

-- Let's see how Framing helps here
SELECT 
	AccountNumber,
	OrderDate, 
	First_VALUE(OrderDate) 
		OVER (	PARTITION BY AccountNumber 
				ORDER BY OrderDate 
				ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) AS FirstOrderDate,
	LAST_VALUE(OrderDate) 
		OVER (	PARTITION BY AccountNumber 
				ORDER BY OrderDate 
				ROWS BETWEEN CURRENT ROW AND UNBOUNDED FOLLOWING) AS LastOrderDate
FROM AdventureWorks2012.Sales.SalesOrderHeader


-- Let's see how Framing helps here
SELECT 
	AccountNumber,
	OrderDate, 
	First_VALUE(OrderDate) 
		OVER (	PARTITION BY AccountNumber 
				ORDER BY OrderDate 
				ROWS BETWEEN UNBOUNDED PRECEDING AND UNBOUNDED FOLLOWING) AS FirstOrderDate,
	LAST_VALUE(OrderDate) 
		OVER (	PARTITION BY AccountNumber 
				ORDER BY OrderDate 
				ROWS BETWEEN UNBOUNDED PRECEDING AND UNBOUNDED FOLLOWING) AS LastOrderDate
FROM AdventureWorks2012.Sales.SalesOrderHeader

-- Let's see how we would have gotten here previously?
SELECT soh.AccountNumber, OrderDate, FirstOrderDate, LastOrderDate
FROM Sales.SalesOrderHeader AS soh
JOIN (
SELECT 
	AccountNumber,
	MIN(OrderDate) AS FirstOrderDate, 
	MAX(OrderDate) AS LastOrderDate
FROM AdventureWorks2012.Sales.SalesOrderHeader
GROUP BY AccountNumber) AS tab ON tab.AccountNumber = soh.AccountNumber

